/**
  ******************************************************************************
  * File Name          : main.c
  * Description        : Main program body
  ******************************************************************************
  ** This notice applies to any and all portions of this file
  * that are not between comment pairs USER CODE BEGIN and
  * USER CODE END. Other portions of this file, whether 
  * inserted by the user or by software development tools
  * are owned by their respective copyright owners.
  *
  * COPYRIGHT(c) 2019 STMicroelectronics
  *
  * Redistribution and use in source and binary forms, with or without modification,
  * are permitted provided that the following conditions are met:
  *   1. Redistributions of source code must retain the above copyright notice,
  *      this list of conditions and the following disclaimer.
  *   2. Redistributions in binary form must reproduce the above copyright notice,
  *      this list of conditions and the following disclaimer in the documentation
  *      and/or other materials provided with the distribution.
  *   3. Neither the name of STMicroelectronics nor the names of its contributors
  *      may be used to endorse or promote products derived from this software
  *      without specific prior written permission.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
  * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
  * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
  * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  *
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "stm32f1xx_hal.h"
#include "adc.h"
#include "LCD_2x16.h"
#include "tim.h"
#include "gpio.h"

/* USER CODE BEGIN Includes */

/* USER CODE END Includes */

/* Private variables ---------------------------------------------------------*/

 uint32_t adc1;
/* USER CODE BEGIN PV */
/* Private variables ---------------------------------------------------------*/

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);

/* USER CODE BEGIN PFP */
/* Private function prototypes -----------------------------------------------*/

/* USER CODE END PFP */

/* USER CODE BEGIN 0 */

/* USER CODE END 0 */

int main(void)
{

  /* USER CODE BEGIN 1 */

  /* USER CODE END 1 */

  /* MCU Configuration----------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_TIM1_Init();
  MX_ADC1_Init();

  /* USER CODE BEGIN 2 */
  HAL_TIM_PWM_Start(&htim1, TIM_CHANNEL_1);
  TIM1->CCR1=0;
  /* USER CODE END 2 */
  LCD_HandleTypeDef lcd;
	
	/* lcd configuration */
	
  lcd.RS.Port = GPIOC;      
  lcd.RS.Pin = GPIO_PIN_14;
  
  lcd.EN.Port = GPIOC;
  lcd.EN.Pin = GPIO_PIN_15;
  
  lcd.DB4.Port = GPIOA;
  lcd.DB4.Pin = GPIO_PIN_4;
  
  lcd.DB5.Port = GPIOA;
  lcd.DB5.Pin = GPIO_PIN_5;
  
  lcd.DB6.Port = GPIOA;
  lcd.DB6.Pin = GPIO_PIN_6;
  
  lcd.DB7.Port = GPIOA;
  lcd.DB7.Pin = GPIO_PIN_7;
  HAL_Delay(100);
  LCD_sendCmd(&lcd, 0x33); // Initialize controller
  LCD_sendCmd(&lcd, 0x32); // Set 4-bit mode
  LCD_sendCmd(&lcd, 0x28); // 4 bit, 2 line, 5x7
  LCD_sendCmd(&lcd, 0x06); // Cursor direction -> right
  LCD_sendCmd(&lcd, 0x0C); // Display on, cursor off
  LCD_sendCmd(&lcd, 0x01); // Clear display
  HAL_Delay(100);

  /* USER CODE BEGIN 2 */
  short int delay=0;
  int line = 0, position = 0, x=0;  
  long cycle_duty=0; 
  /* Infinite loop */
	 line = 1, position = 0;
   LCD_sendCmd(&lcd, 0x80 | (line*0x40 + position)); // change cursor 
   LCD_TEXT_PUTS(&lcd, "STM32F103C8T6");
	 HAL_Delay(2000);
	 LCD_sendCmd(&lcd, 0x01);
	 
  while (1)
  {
  /* USER CODE END WHILE */
		
    HAL_ADC_Start(&hadc1);
	  HAL_ADC_PollForConversion(&hadc1, 100);
	  adc1 = HAL_ADC_GetValue(&hadc1);
		if(adc1 ==0) TIM1->CCR1=0; 
		TIM1->CCR1= adc1*16; 
    HAL_Delay(10);
		for(delay=0; delay<=10; delay++) {
		 cycle_duty=(adc1 * 9999)/4095;
	   x=cycle_duty/1000; 
	   line = 0, position = 4;
     LCD_sendCmd(&lcd, 0x80 | (line*0x40 + position)); // change cursor 
     LCD_TEXT_PUTS(&lcd, "Cycle_duty");
	   line = 1, position = 4;
	   LCD_sendCmd(&lcd, 0x80 | (line*0x40 + position)); // change cursor 
     LCD_ONE_PUTS(&lcd, x);
	   x=(cycle_duty/100)%10; 	
	   line = 1, position = 5;
	   LCD_sendCmd(&lcd, 0x80 | (line*0x40 + position)); // change cursor
	   LCD_ONE_PUTS(&lcd, x);	
     line = 1, position = 6;
	   LCD_sendCmd(&lcd, 0x80 | (line*0x40 + position)); // change cursor 
     LCD_TEXT_PUTS(&lcd, "."); 		
	   x=(cycle_duty/10)%10; 	
	   line = 1, position = 7;
	   LCD_sendCmd(&lcd, 0x80 | (line*0x40 + position)); // change cursor 	
     LCD_ONE_PUTS(&lcd, x);
	   x= cycle_duty %10; 	
	   line = 1, position = 8;
	   LCD_sendCmd(&lcd, 0x80 | (line*0x40 + position)); // change cursor 	
     LCD_ONE_PUTS(&lcd, x);
		 line = 1, position = 10;
     LCD_sendCmd(&lcd, 0x80 | (line*0x40 + position)); // change cursor 
     LCD_TEXT_PUTS(&lcd, "%");
	   HAL_Delay(1);
	   HAL_ADC_Stop (&hadc1);	
  /* USER CODE BEGIN 3 */

   }
  /* USER CODE END 3 */
 }  
	
}

/** System Clock Configuration
*/
void SystemClock_Config(void)
{

  RCC_OscInitTypeDef RCC_OscInitStruct;
  RCC_ClkInitTypeDef RCC_ClkInitStruct;
  RCC_PeriphCLKInitTypeDef PeriphClkInit;

    /**Initializes the CPU, AHB and APB busses clocks 
    */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.HSEPredivValue = RCC_HSE_PREDIV_DIV1;
  RCC_OscInitStruct.HSIState = RCC_HSI_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLMUL = RCC_PLL_MUL9;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    _Error_Handler(__FILE__, __LINE__);
  }

    /**Initializes the CPU, AHB and APB busses clocks 
    */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV2;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_2) != HAL_OK)
  {
    _Error_Handler(__FILE__, __LINE__);
  }

  PeriphClkInit.PeriphClockSelection = RCC_PERIPHCLK_ADC;
  PeriphClkInit.AdcClockSelection = RCC_ADCPCLK2_DIV6;
  if (HAL_RCCEx_PeriphCLKConfig(&PeriphClkInit) != HAL_OK)
  {
    _Error_Handler(__FILE__, __LINE__);
  }

    /**Configure the Systick interrupt time 
    */
  HAL_SYSTICK_Config(HAL_RCC_GetHCLKFreq()/1000);

    /**Configure the Systick 
    */
  HAL_SYSTICK_CLKSourceConfig(SYSTICK_CLKSOURCE_HCLK);

  /* SysTick_IRQn interrupt configuration */
  HAL_NVIC_SetPriority(SysTick_IRQn, 0, 0);
}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @param  None
  * @retval None
  */
void _Error_Handler(char * file, int line)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */
  while(1) 
  {
  }
  /* USER CODE END Error_Handler_Debug */ 
}

#ifdef USE_FULL_ASSERT

/**
   * @brief Reports the name of the source file and the source line number
   * where the assert_param error has occurred.
   * @param file: pointer to the source file name
   * @param line: assert_param error line source number
   * @retval None
   */
void assert_failed(uint8_t* file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
    ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */

}

#endif

/**
  * @}
  */ 

/**
  * @}
*/ 

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
